// beosmain.h	BeOS stuff - part of LinCity
// Copyright (c) I J Peters 1995,1996.  Please read the file 'COPYRIGHT'.

// Modified by T.Murai
/////////////////////////////////////////////////////////////////////////
// This source cde is modified from
// BeOS port of xgalaga-2.0 by Mike Steed 
/////////////////////////////////////////////////////////////////////////
#ifndef BEOSMAIN_H_INCLUDED
#define BEOSMAIN_H_INCLUDED

#include <Application.h>
#include <Window.h>
#include <View.h>
#include <Bitmap.h>
#include <Looper.h>
#include <Locker.h>
#include <List.h>
#include <BlockCache.h>
#include <Roster.h>
#include "beosdefs.h"

#define kMsgGo	'GO!!'

extern W_Window BaseWin;
extern int real_quit_flag;

class MainThread: public BLooper
{
    private:
	bool	_quitRequested;

    public:
		MainThread(): _quitRequested(false), BLooper("cmain") { Run(); }
		~MainThread() { }

	void	requestQuit();

	void	MessageReceived(BMessage *m);
};


class LinCityView: public BView 
{
    private:
	BLocker	    _eventLock;
	BList	    _eventList;
	BBlockCache _memPool;

    public:
		LinCityView(BRect frame); 

	bool	eventsPending();
	void	nextEvent(W_Event *event);

	void	Draw(BRect r);
	void	KeyDown(const char *bytes, int32 numBytes);
	void	KeyUp(const char *bytes, int32 numBytes);
	void	MouseDown(BPoint p);
	void	MouseUp(BPoint p);
};


class LinCityWin: public BWindow 
{
    private:
	bool	_zoomed;

    public:
		LinCityWin(); 
		~LinCityWin(); 

	void	Zoom(BPoint rec_position, float rec_width, float rec_height);
	bool	QuitRequested();
};


class LinCity: public BApplication 
{
    private:
	MainThread *_mainThread;

    public:
		LinCity();
	virtual ~LinCity();

	void	ArgvReceived(int32 argc, char **argv);
	void	ReadyToRun();
};

#endif //BEOSMAIN_H_INCLUDED