// lcBeOS.h   Header file for lcbeos.cxx - part of LinCity.
// Copyright (c) I J Peters 1995,1996.  Please read the file 'COPYRIGHT'.

// Modified for BeOS by T.Murai

#ifndef LCBEOS_H_INCLUDED
#define LCBEOS_H_INCLUDED

#include <View.h>
#include "beosdefs.h"

#define TRUE 1
#define FALSE 0
#define MOUSE_LEFTBUTTON B_PRIMARY_MOUSE_BUTTON
#define MOUSE_RIGHTBUTTON B_SECONDARY_MOUSE_BUTTON

#define WINWIDTH 640    /* default window width */
#define WINHEIGHT 480   /* default window height */
#define FATAL   -1
#define WARNING -2



extern int     mouse_button,cs_mouse_shifted;
extern char    myfont[256*8];
extern int     verbose;
extern int    pix_double;
extern int     text_bg;
extern int     text_fg;
extern int     x_key_value;
extern int     borderx,bordery;
extern int     xclip_x1,xclip_y1,xclip_x2,xclip_y2,clipping_flag;
extern unsigned char *open_font;
extern int open_font_height;
extern int no_init_help;
extern char colour_pal_file[],fontfile[];
extern int cs_mouse_x,cs_mouse_y;
extern float gamma_correct_red,gamma_correct_green,gamma_correct_blue;

extern rgb_color pal[];


#ifdef USE_PIXMAPS
extern Pixmap icon_pixmap[];
extern struct TYPE main_types[];
#endif

// Functions
void gl_setpalettecolor(int,int,int,int);
void RefreshScreen (void);
void RefreshArea (int,int,int,int);

void Fgl_setpixel (int x, int y, int col);
int Fgl_getpixel (int x, int y);

void Fgl_line (int x1, int y1, int dummy, int y2, int col);
void Fgl_hline (int x1, int y1, int x2, int col);

void Fgl_setfontcolors (int bg, int fg);
void Fgl_write (const int x, const int y, const char *s);
void open_write (int x, int y, char *s);

void Fgl_fillbox (int x1, int y1, int w, int h, int col);

void Fgl_putbox (const int x1, const int y1, const int w, const int h, void *buf);
void Fgl_getbox (int x1, int y1, int w, int h, void *buf);

void Fgl_enableclipping (void);
void Fgl_disableclipping (void);
void Fgl_setclippingwindow (int x1, int y1, int x2, int y2);

void call_wait_event (void);
void call_event (void);
int W_EventsPending(void);
void W_NextEvent(W_Event *wevent);
void HandleEvent (W_Event * event);


void parse_args (int argc, char **argv);
void HandleError (char *description, int degree);

#endif //LCBEOS_H_INCLUDED
